
/*  @(#)input.c 1.4 95/02/06
 *
 *  Various routines associated with the input popup.
 *
 *  Copyright (c) Rich Burridge.    All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors or inaccuracies inherent
 *  either to the comments or the code of this program, but if
 *  reported to me then an attempt will be made to fix them.
 */

#include "mptool.h"

Widget ipopup ;         /* Input options popup. */
Widget *iwarr ;


void
do_input_apply(void)
{
  char *prologue = get_str_value(F_INPUT, WI_PROLOGUE) ;
 
  if (prologue && *prologue != '\0') STRCPY(proname, prologue) ;
  set_int_opt_val(O_FOLDER,  get_bool_value(F_INPUT, WI_INPUT_FOLDER)) ;
  set_int_opt_val(O_DIGEST,  get_bool_value(F_INPUT, WI_INPUT_DIGEST)) ;
  set_int_opt_val(O_ELM,     get_bool_value(F_INPUT, WI_INPUT_ELM)) ;
  set_int_opt_val(O_PR_ORIG, get_bool_value(F_INPUT, WI_INPUT_FROM)) ;
  set_int_opt_val(O_CONTENT, get_bool_value(F_INPUT, WI_INPUT_CONTENT)) ;
  set_int_opt_val(O_MODTIME, get_bool_value(F_INPUT, WI_INPUT_MODTIME)) ;
}
 
 
void
do_input_dismiss(void)
{
  XtUnmapWidget(ipopup) ;
  XtUnmanageChild(ipopup) ;
}
 
 
void
do_input_reset(void)
{
  set_str_value(F_INPUT,  WI_PROLOGUE,      proname) ;
  set_bool_value(F_INPUT, WI_INPUT_FOLDER,  int_opt_val(O_FOLDER)) ;
  set_bool_value(F_INPUT, WI_INPUT_DIGEST,  int_opt_val(O_DIGEST)) ;
  set_bool_value(F_INPUT, WI_INPUT_ELM,     int_opt_val(O_ELM)) ;
  set_bool_value(F_INPUT, WI_INPUT_FROM,    int_opt_val(O_PR_ORIG)) ;
  set_bool_value(F_INPUT, WI_INPUT_CONTENT, int_opt_val(O_CONTENT)) ;
  set_bool_value(F_INPUT, WI_INPUT_MODTIME, int_opt_val(O_MODTIME)) ;
}


void
do_show_input(void)
{
  if (!ipopup)
    {
      ipopup = tu_input_frame_widget("input", warr[WI_MAIN_FRAME],
                                     &iwarr) ;
      add_delete_callback(ipopup) ;
      add_help(iwarr[WI_INPUT_FORM],        wi_input_frame_help) ;
      add_help(iwarr[WI_PROLOGUE_LABEL],    wi_prologue_help) ;
      add_help(iwarr[WI_PROLOGUE],          wi_prologue_help) ;
      add_help(iwarr[WI_INPUT_FOLDER],      wi_opt_folder_help) ;
      add_help(iwarr[WI_INPUT_DIGEST],      wi_opt_digest_help) ;
      add_help(iwarr[WI_INPUT_ELM],         wi_props_elm_help) ;
      add_help(iwarr[WI_INPUT_FROM],        wi_props_from_help) ;
      add_help(iwarr[WI_INPUT_CONTENT],     wi_props_content_help) ;
      add_help(iwarr[WI_INPUT_MODTIME],     wi_props_modtime_help) ;
      add_help(iwarr[WI_INPUT_APPLY],       wi_input_apply_help) ;
      add_help(iwarr[WI_INPUT_RESET],       wi_input_reset_help) ;
      add_help(iwarr[WI_INPUT_DISMISS],     wi_input_dismiss_help) ;
      do_input_reset() ;
    }
  show_popup(ipopup) ;
}


void
Input(void)
{
  iwarr = NULL ;           /* No widgets defined initially. */
  ipopup = NULL ;          /* No input popup window initially. */
}
